Package: tomoseqr
Title: R Package for Analyzing Tomo-seq Data
Version: 1.15.0
Authors@R: 
    person(
        given = "Ryosuke",
        family = "Matsuzawa",
        role = c("aut", "cre"),
        email = "kinakomochi.work@gmail.com",
        comment = c(ORCID = "0000-0003-2999-4734")
    )
Description: `tomoseqr` is an R package for analyzing Tomo-seq data.
    Tomo-seq is a genome-wide RNA tomography method that combines combining
    high-throughput RNA sequencing with cryosectioning for spatially resolved transcriptomics.
    `tomoseqr` reconstructs 3D expression patterns from tomo-seq data
    and visualizes the reconstructed 3D expression patterns.
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: FALSE
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.2
VignetteBuilder: knitr
Depends: R (>= 4.2)
biocViews: GeneExpression, Sequencing, RNASeq, Transcriptomics,
        Spatial, Visualization, Software
Imports: grDevices, graphics, animation, tibble, dplyr, stringr, purrr,
        methods, shiny, BiocFileCache, readr, tools, plotly, ggplot2
Suggests: rmarkdown, knitr, BiocStyle, testthat (>= 3.0.0)
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/tomoseqr
git_branch: devel
git_last_commit: 5f3f9ac
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 23:27:12 UTC; biocbuild
Author: Ryosuke Matsuzawa [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2999-4734>)
Maintainer: Ryosuke Matsuzawa <kinakomochi.work@gmail.com>

# tomoseqr

`tomoseqr` is an R package for analyzing Tomo-seq (a method to obtain
genome-wide expression data with spatial resolution) data. The algorithm
of image reconstruction is based on [Junker et al, 2014.](#reference)

## Usage

### Installation

```{r}
library(devtools)
install_github("bioinfo-tsukuba/tomoseqr")
```

### Data preparation

Please prepare Tomo-seq data that meets the following requirements.

1. It is a `data.frame` object for each axis.
1. Its **first cloumn** has gene ID. It's not enough that only row
names indicate gene ID.
1. The order of the second and subsequent columns should be the same as
the order of the sections.
1. It has a header.

#### Data example

```{r}
  gene_ID   section1 section2   section3   section4
1   gene1   0.000000   0.0000 2867.75420 9086.81135
2   gene2 440.599448 531.7915   36.91591  484.06813
3   gene3  75.446821 833.9432  736.82367  559.89157
4   gene4 506.865166 930.0414  880.26654   52.85974
5   gene5   2.159842 271.6788  210.06446  445.08979
```

## Example usage

```{r}
library(tomoseqr)
data("testx", "testy", "testz", "mask")
tomo_obj <- Estimate3dExpressions(
    testx,
    testy,
    testz,
    mask=mask,
    query=c("gene1", "gene2")
)
ImageViewer(tomo_obj, "gene1")
```

![example](./inst/images/imageviewer_example.png)

```{r}
Animate2d(tomo_obj, "gene1", target="unite")
```

![example](./inst/images/gene1_unite_1_2.gif)

## Reference

Junker et al. Genome-wide RNA Tomography in the Zebrafish Embryo.
*Cell*, 2014.  
<https://doi.org/10.1016/j.cell.2014.09.038>

## Contact

Ryosuke Matsuzawa / [shingenmochi](https://github.com/shingenmochi)

#' Output the reconstructed expression pattern as an image.
#' @param tomoObj tomoSeq object
#' @importFrom shiny
#'    reactive
#'    animationOptions
#'    plotOutput
#'    renderPlot
#'    sidebarLayout
#'    sliderInput
#'    tabPanel
#'    tabsetPanel
#'    textInput
#'    hr
#'    h3
#'    column
#'    selectInput
#'    fluidRow
#'    uiOutput
#'    checkboxInput
#'    renderUI
#' @importFrom grDevices
#'    png
#'    dev.off
#' @importFrom plotly
#'    plot_ly
#'    add_markers
#'    layout
#'    config
#'    plotlyOutput
#'    renderPlotly
#' @importFrom dplyr
#'    sym
#' @importFrom ggplot2
#'    geom_tile
#'    aes
#'    ggtitle
#'    ggsave
#'    ggplot
#'    scale_fill_gradientn
#'    ylim
#'    xlim
#'    theme_minimal
#'    theme
#'    element_rect
#'    element_text
#'    element_line
#'    element_blank
#' @return NA
#' @examples
#' if (interactive()) {
#'     data(tomoObj)
#'     imageViewer(tomoObj, "gene2")
#' }
#' @export
imageViewer <- function (tomoObj) {
    ui <- function () {
        fluidPage(
            titlePanel("Image viewer"),
            selectInput(
                "geneID",
                label = h4("Gene ID"),
                choices = names(tomoObj[["results"]])
            ),
            fluidRow(
                column(4,
                    textInput(
                        "xlab",
                        label = "x label",
                        value = "x"
                    )
                ),
                column(4,
                    textInput(
                        "ylab",
                        label = "y label",
                        value = "y"
                    )
                ),
                column(4,
                    textInput(
                        "zlab",
                        label = "z label",
                        value = "z"
                    )
                )
            ),
            h4("Section width (relative value)"),
            fluidRow(
                column(4,
                    numericInput(
                        "xWidth",
                        label = "x",
                        value = 1
                    )
                ),
                column(4,
                    numericInput(
                        "yWidth",
                        label = "y",
                        value = 1
                    )
                ),
                column(4,
                    numericInput(
                        "zWidth",
                        label = "z",
                        value = 1
                    )
                )
            ),
            tabsetPanel(
                type="tabs",

                tabPanel(
                    "2D view",
                    # hr(),
                    sidebarLayout(
                        sidebarPanel(
                            selectInput(
                                "angle",
                                label = h4("Select Angle"),
                                choices = c("x", "y", "z")
                            ),
                            uiOutput("sectionSlider"),
                            uiOutput("title"),
                            uiOutput("zlim_slider"),
                            downloadButton(
                                "XdownloadFig",
                                label = "Download figure"
                            ),
                            downloadButton(
                                "XgenerateGIF",
                                label = "Download GIF"
                            )
                        ),
                        mainPanel(
                            plotOutput("xplot", height = "800px", width="800px")
                        )
                    )
                ),
                tabPanel(
                    "3D view",
                    sidebarLayout(
                        sidebarPanel(
                            numericInput(
                                "threshold_3D",
                                label = h4("Threshold"),
                                value = 1
                            ),
                            numericInput(
                                "exp_size_3D",
                                label = h4("size of expression dots"),
                                value = 40
                            ),
                            numericInput(
                                "exp_opacity_3D",
                                label = h4("Opacity of expression dots"),
                                value = 80
                            ),
                            numericInput(
                                "mask_size_3D",
                                label = h4("size of mask dots"),
                                value = 2
                            ),
                            numericInput(
                                "mask_opacity_3D",
                                label = h4("Opacity of mask dots"),
                                value = 70
                            ),
                            textInput(
                                "mask_color_3D",
                                label = h4("color of mask dots"),
                                value = "#999999"
                            ),
                            checkboxInput(
                                "addMask_3D",
                                label = "Add Mask",
                                value = TRUE
                            )
                        ),
                        mainPanel(
                            plotlyOutput(
                                "choice_3D",
                                height = "800px",
                                width = "800px"
                            )
                        )
                    )
                )
            )
        )
    }
    server <- function (input, output) {
    maskResult <- tomoObj$mask
    axesOrder <- list(
        "x" = c("y", "z", "x"),
        "y" = c("x", "z", "y"),
        "z" = c("x", "y", "z")
    )
    maskAlong <- list()
    maskDim <- dim(maskResult)
    dimOrder <- list(
        "x" = c(maskDim[2], maskDim[3], maskDim[1]),
        "y" = c(maskDim[1], maskDim[3], maskDim[2]),
        "z" = maskDim
    )
    maskAlong[["x"]] <- aperm(maskResult, perm = c(2, 3, 1))
    maskAlong[["y"]] <- aperm(maskResult, perm = c(1, 3, 2))
    maskAlong[["z"]] <- aperm(maskResult, perm = c(1, 2, 3))

    recResult <- reactive({
        tomoObj[["results"]][[input$geneID]][["reconst"]]
    })
    recAlong <- reactive({
        recAlong <- list()
        recAlong[["x"]] <- aperm(recResult(), perm = c(2, 3, 1))
        recAlong[["y"]] <- aperm(recResult(), perm = c(1, 3, 2))
        recAlong[["z"]] <- aperm(recResult(), perm = c(1, 2, 3))
        return(recAlong)
    })
    
    output$sectionSlider <- renderUI({
        max <- dimOrder[[input$angle]][3]
        sliderInput(
            "xSec",
            "Section",
            min=1,
            max=max,
            step=1,
            value=1,
            animate = animationOptions(
                interval=400,
                loop=TRUE
            )
        )
    })
    output$title <- renderUI({
        textInput(
            "main",
            label="Title",
            value=input$geneID
        )
    })

    output$zlim_slider <- renderUI({
        sliderMax <- ceiling(max(recResult()))
        sliderInput(
            "x_zlim",
            "zlim",
            min=0,
            max=sliderMax,
            step=1,
            value=c(0, sliderMax),
        )
    })

        maskDf <- matrixToDataFrame(tomoObj[["mask"]])
        expDf <- reactive({
            (toDataFrame(tomoObj, input$geneID))[maskDf[, 4] == 1,]
        })

        labelOrder <- reactive({
            list(
            "x" = c(input$ylab, input$zlab),
            "y" = c(input$xlab, input$zlab),
            "z" = c(input$xlab, input$ylab)
            )
        })
        widthOrder <- reactive({
            list(
            "x" = c(input$yWidth, input$zWidth),
            "y" = c(input$xWidth, input$zWidth),
            "z" = c(input$xWidth, input$yWidth)
            )
        })
        base_plot <- reactive({
            makeBasePlot(
                expDf = expDf(),
                xAxis = axesOrder[[input$angle]][1],
                yAxis = axesOrder[[input$angle]][2],
                xMax = dimOrder[[input$angle]][1],
                yMax = dimOrder[[input$angle]][2],
                xAsp = dimOrder[[input$angle]][1] *
                    widthOrder()[[input$angle]][1],
                yAsp = dimOrder[[input$angle]][2] *
                    widthOrder()[[input$angle]][2],
                xlabel = labelOrder()[[input$angle]][1],
                ylabel = labelOrder()[[input$angle]][2],
                zlim = input$x_zlim
            )
        })
        plot2D <- reactive({
            if (is.null(input$xSec)) {
                message("Please wait...")
            } else {
                xAxis <- sym(axesOrder[[input$angle]][1])
                yAxis <- sym(axesOrder[[input$angle]][2])
                fill <- sym("value")
                return(
                base_plot() +
                    geom_tile(
                        data=expDf()[expDf()[[input$angle]] == input$xSec,],
                        aes(
                            x = !!xAxis,
                            y = !!yAxis,
                            fill = !!fill
                        )
                    ) +
                    ggtitle(str_c(input$main, " : ", input$xSec))
                )
            }
        })
        
        output$xplot <- renderPlot({
            if (is.null(input$xSec)) {
                message("Please wait...")
            } else {
                print(plot2D())
            }
        })

        output$XdownloadFig <- downloadHandler(
            filename = reactive({str_c(input$geneID, ".png")}),
            content = function (file) {
                ggsave(
                    file,
                    plot = plot2D(),
                    height=800,
                    width=800,
                    units = "px",
                    scale = 5
                )
            }
        )

        output$XgenerateGIF <- downloadHandler(
            filename = "xPlot.gif",
            content = function (file) {
                tomoObj[["mask"]] <- maskResult
                animate2d(
                    tomoObj,
                    input$geneID,
                    along = input$angle,
                    main=input$main,
                    xlab=labelOrder()[[input$angle]][1],
                    ylab=labelOrder()[[input$angle]][2],
                    file=file,
                    zlim=input$x_zlim,
                    interval=0.1,
                    aspectX = widthOrder()[[input$angle]][1],
                    aspectY = widthOrder()[[input$angle]][2]
                )
            }
        )

        tomoObj$mask <- plotsurface(tomoObj$mask)
        output$choice_3D <- renderPlotly(
            showExp(
                tomoObj,
                geneID = input$geneID,
                threshold = input$threshold_3D,
                xlab = input$xlab,
                ylab = input$ylab,
                zlab = input$zlab,
                addMask = input$addMask_3D,
                exp_size = input$exp_size_3D,
                exp_opacity = input$exp_opacity_3D,
                mask_size = input$mask_size_3D,
                mask_opacity = input$mask_opacity_3D,
                mask_color = input$mask_color_3D,
                aspX = input$xWidth,
                aspY = input$yWidth,
                aspZ = input$zWidth
            )
        )
    }
    shinyApp(ui, server)
}

#' Extract geneIDs to which hoge can be applied.
#' @param x A data.frame object containing a Tomo-seq data
#' for x-axis sections. The rows represent genes. The first column
#' contains gene IDs and the second and subsequent columns contain
#' gene expression levels in sections.
#' @param y A data.frame object containing a Tomo-seq data for y-axis
#' sections. The rows represent genes. The first column contains gene IDs and
#' the second and subsequent columns contain gene expression levels in sections.
#' @param z A data.frame object containing a Tomo-seq data for
#' z-axis sections. The rows represent genes. The first column
#' contains gene IDs and the second and subsequent columns contain
#' gene expression levels in sections.
#' @return A vector that contains genes which can be used for
#' `estimate3dExpressions`.
#' @examples
#' data("testx", "testy", "testz")
#' extractGeneList(testx, testy, testz)
#' @importFrom dplyr %>%
#' @export
extractGeneList <- function (x, y, z) {
    xGene <- x[, 1] %>% t()
    yGene <- y[, 1] %>% t()
    zGene <- z[, 1] %>% t()
    xAndy <- intersect(xGene, yGene)
    return(intersect(xAndy, zGene))
}

#' Estimate 3d expressions
#' @param x A data.frame object containing a simulated Tomo-seq data
#' for x-axis sections. The rows represent genes. The first column
#' contains gene IDs and the second and subsequent columns contain
#' gene expression levels in sections.
#' @param y A data.frame object containing a simulated Tomo-seq data for y-axis
#' sections. The rows represent genes. The first column contains gene IDs and
#' the second and subsequent columns contain gene expression levels in sections.
#' @param z A data.frame object containing a simulated Tomo-seq data for
#' z-axis sections. The rows represent genes. The first column
#' contains gene IDs and the second and subsequent columns contain
#' gene expression levels in sections.
#' @param mask A 3D array that represents if each boxel is included to sample.
#' You can make a mask using `masker`.
#' @param query Vector of gene IDs
#' @param numIter How many times iterate
#' @param normalize Whether to normalize so that total expression per sample
#' volume is equal between sections.
#' @return tomoSeq object
#' @importFrom purrr list_along
#' @examples
#' data("testx", "testy", "testz", "mask")
#' estimate3dExpressions(
#'     testx,
#'     testy,
#'     testz,
#'     mask = mask,
#'     query = c("gene1"), 
#'     normalize = TRUE
#' )
#' @export
estimate3dExpressions <- function (
    x,
    y,
    z,
    mask,
    query,
    numIter = 100,
    normalize=TRUE
) {
    recList <- lapply(
        X=query,
        FUN=singleEstimate,
        dataX=x,
        dataY=y,
        dataZ=z,
        mask=mask,
        normalize=normalize,
        numIter=numIter
    )
    names(recList) <- query
    retList <- list(
        "mask" = mask,
        "results" = recList
    )
    class(retList) <- "tomoSeq"
    return(retList)
}


#' Plot the trend of the value of the loss function.
#' @param tomoObj tomoSeq object
#' @param geneID single gene ID (string)
#' @importFrom dplyr %>%
#' @return NA
#' @examples
#' data(tomoObj)
#' plotLossFunction(tomoObj, "gene2")
#' @export
plotLossFunction <- function (tomoObj, geneID) {
    checkParameters(tomoObj, geneID)
    tomoObj[["results"]][[geneID]][["errFunc"]] %>%
        plot(
            type = "l",
            main = geneID,
            xlab = "Iteration number",
            ylab = "Loss"
        )
}

#' Animate 2D expressions along one axis and generate GIF file.
#' @param tomoObj tomoSeq object
#' @param geneID single gene ID (string)
#' @param along Parameter specifying along which axis the cross section should
#' be plotted.
#' @param main A string used for the title of the plot. Default is `geneID`.
#' @param xlab Label of x axis. Default is `xaxis`.
#' @param ylab Label of y axis. Default is `yaxis`.
#' @param file Path of GIF file.
#' @param zlim Limit of value of heatmap. If target="mask", it is ignored.
#' @param interval interval of GIF animation.
#' @param aspectX Width of figure. If you don't specify the value of
#' this parameter, It is calculated based on the number of sections
#' Corresponding to the horizontal axis
#' @param aspectY Height of figure. If you don't specify the value of
#' this parameter, It is calculated based on the number of sections
#' Corresponding to the vertical axis
#' @importFrom stringr str_c
#' @importFrom dplyr %>%
#' @importFrom animation saveGIF
#' @importFrom shiny
#' getDefaultReactiveDomain
#' withProgress
#' @return It generate GIF file.
#' @examples
#' if(interactive()) {
#'     data(tomoObj)
#'     animate2d(tomoObj, "gene2", target = "expression", file = "example.gif")
#' }
#' @export
animate2d <- function (
    tomoObj,
    geneID,
    along = "x",
    main=geneID,
    xlab="x",
    ylab="y",
    file=str_c(geneID, "_", along, ".gif"),
    zlim=NA,
    interval=0.1,
    aspectX = 1,
    aspectY = 1
) {
    checkParameters(tomoObj, geneID)
    if (!(along %in% c("x", "y", "z"))) {
        stop("`along` should be 'x', 'y' or 'z'.")
    }
    # if (length(aspectRatio) != 0 & length(aspectRatio) != 2) {
    #     stop("`aspectRatio` should be a 2D vector.")
    # }

    maskDf <- matrixToDataFrame(tomoObj[["mask"]])
    expDf <- toDataFrame(tomoObj, geneID)
    expDf <- expDf[maskDf[, 4] == 1,]
    maskDim <- dim(tomoObj[["mask"]])
    dimOrder <- list(
        "x" = c(maskDim[2], maskDim[3], maskDim[1]),
        "y" = c(maskDim[1], maskDim[3], maskDim[2]),
        "z" = maskDim
    )
    axesOrder <- list(
        "x" = c("y", "z", "x"),
        "y" = c("x", "z", "y"),
        "z" = c("x", "y", "z")
    )

    if (is.na(zlim[1])) {
        zlimParameter <- c(0, max(expDf[,4]))
    } else {
        zlimParameter <- zlim
    }

        print(dimOrder[[along]][1])
    basePlot <- makeBasePlot(
        expDf = expDf,
        xAxis = axesOrder[[along]][1], 
        yAxis = axesOrder[[along]][2],
        xMax = dimOrder[[along]][1],
        yMax = dimOrder[[along]][2],
        xAsp = dimOrder[[along]][1] * aspectX,
        yAsp = dimOrder[[along]][2] * aspectY,
        xlabel = xlab,
        ylabel = ylab,
        zlim = zlimParameter
    )

    generateGIF <- function (forShiny) {
        saveGIF(
            animateForGIF(
                basePlot = basePlot,
                expDf = expDf,
                dimOrder = dimOrder,
                along = along,
                xAxis = axesOrder[[along]][1],
                yAxis = axesOrder[[along]][2],
                main = main,
                forShiny = forShiny
            ),
            movie.name=file,
            interval=interval,
            ani.width=800,
            ani.height=800,
            autobrowse=FALSE
        )
    }
    if (is.null(getDefaultReactiveDomain())) {
        generateGIF(forShiny = FALSE)
    } else {
        withProgress(message='generating GIF. It takes long time...', value=0, {
            generateGIF(forShiny = TRUE)
        })
    }
}

#' Plot expression of single gene along an axis
#' @param tomoObj tomoSeq object
#' @param geneID single gene ID (string)
#' @param axes axis ("x", "y" or "z")
#' @importFrom graphics par
#' @return NA
#' @examples
#' data(tomoObj)
#' plot1dExpression(tomoObj, "gene2", "x")
#' @export
plot1dExpression <- function (tomoObj, geneID, axes) {
    checkParameters(tomoObj, geneID)
    convertList <- list("x" = 1, "y" = 2, "z" = 3)
    oldpar <- par(no.readonly=TRUE)
    on.exit(par(oldpar))
    marginal <- tomoObj[["results"]][[geneID]][[axes]]
    plot(marginal, type="l", lty=3, axes=FALSE, ann=FALSE)
    par(new=TRUE)
    plot(
        apply(
            tomoObj[["results"]][[geneID]][["reconst"]],
            convertList[[axes]],
            sum
        ),
        type="l",
        lty=2,
        ylim=range(marginal),
        col="red",
        xlab = "Section",
        ylab = "Expression level"
    )
}

#' Plot expressions of all genes along an axis
#' @param tomoSeqData A data.frame object containing a Tomo-seq data
#' for any sections. The rows represent genes. The first column
#' contains gene IDs and the second and subsequent columns contain
#' gene expression levels in sections.
#' @param ... Arguments which are related to plot parameters.
#' Prease refer to \code{\link[graphics]{plot}}.
#' @importFrom dplyr %>%
#' @return NA
#' @examples
#' data("testx")
#' plot1dAllExpression(testx)
#' @export
plot1dAllExpression <- function (tomoSeqData, ...) {
    tomoSeqData[, -1] %>% colSums() %>% plot(type="l", ...)
}

#' Convert reconstructed matrix to data.frame.
#' @param tomoObj tomoSeq object
#' @param geneID single gene ID
#' @importFrom dplyr %>%
#' @return Reconstruction result converted to dataframe.
#' @examples
#' data(tomoObj)
#' toDataFrame(tomoObj, "gene2")
#' @export
toDataFrame <- function (tomoObj, geneID) {
    checkParameters(tomoObj, geneID)
    tomoObj[["results"]][[geneID]][["reconst"]] %>%
        matrixToDataFrame() %>%
        return()
}

#' Get reconstructed matrix
#' @param tomoObj tomoSeq object
#' @param geneID single gene ID
#' @return Reconstruction result as matrix
#' @examples
#' data(tomoObj)
#' getReconstructedResult(tomoObj, "gene2")
#' @export
getReconstructedResult <- function (tomoObj, geneID) {
    checkParameters(tomoObj, geneID)
    return(tomoObj[["results"]][[geneID]][["reconst"]])
}

#' Find peak genes on axial
#' @param tomoSeqData tomo-seq data of any axis
#' @param genes If run for all genes
#' @return A data frame consisting of gene ID, max of expression levels of the
#' gene, mean of expression levels calculated by excluding the maximum value and
#' section number showing the maximum expression level (0 means that there is
#' no such section).
#' @importFrom dplyr select
#' @examples
#' data(testx)
#' findAxialGenes(testx)
#' @export
findAxialGenes <- function (tomoSeqData, genes = "all") {
    if (length(genes) == 1 && genes == "all") {
        tomoSeqData %>%
            findAxialGenesInner() %>%
            return()
    } else {
        tomoSeqData[as.vector(t(tomoSeqData[, 1]) %in% genes), ] %>%
            findAxialGenesInner() %>%
            return()
    }
}

#' Download  part of the Tomo-seq data published by Junker et al.
#' @param verbose If you want to force downloads with or without cache,
#' set this to TRUE.
#' @return BiocFileCache object.
#' @export 
downloadJunker2014 <- function ( verbose = FALSE ) {
    sheldAVURL <- "https://figshare.com/ndownloader/files/38359121"
    sheldVDURL <- "https://figshare.com/ndownloader/files/38359118"
    sheldLRURL <- "https://figshare.com/ndownloader/files/38359115"

    maskURL <- "https://figshare.com/ndownloader/files/38359109"

    bfc <- getTomoseqrCache()
    downloadData(bfc=bfc, rname="sheld_AV", URL=sheldAVURL)
    downloadData(bfc=bfc, rname="sheld_VD", URL=sheldVDURL)
    downloadData(bfc=bfc, rname="sheld_LR", URL=sheldLRURL)
    downloadData(bfc=bfc, rname="mask97x97x97", URL=maskURL)
    return(bfc)
}

#' Load data of Junker2014 from cache.
#' @param tomoseqrCache Cache of tomoseqr. You can get it using
#' `downloadJunker2014`.
#' @return List of tomo-seq data in cache.
#' @importFrom BiocFileCache bfcquery
#' @importFrom readr read_tsv
#' @export
doadJunker2014 <- function (tomoseqrCache) {
    ridAV <- bfcquery(tomoseqrCache, "sheld_AV", "rname")$rid
    ridVD <- bfcquery(tomoseqrCache, "sheld_VD", "rname")$rid
    ridLR <- bfcquery(tomoseqrCache, "sheld_LR", "rname")$rid
    ridMask <- bfcquery(tomoseqrCache, "mask97x97x97", "rname")$rid
    sheldAV <- read_tsv(tomoseqrCache[[ridAV]])
    sheldVD <- read_tsv(tomoseqrCache[[ridVD]])
    sheldLR <- read_tsv(tomoseqrCache[[ridLR]])
    mask <- get(load(tomoseqrCache[[ridMask]]))
    return(
        list(
            sheldAV=sheldAV,
            sheldVD=sheldVD,
            sheldLR=sheldLR,
            mask=mask
        )
    )
}

test_that("Reconstruction of 3D expression pattern", {
    load("trueResults.rda")
    data("testx", "testy", "testz", "mask")
    tomoSeqObject <- estimate3dExpressions(
        testx,
        testy,
        testz,
        mask = mask,
        query = c("gene1", "gene2", "gene3", "gene4"),
        normalize = TRUE
    )
    result1 <- getReconstructedResult(tomoSeqObject, "gene1")
    result2 <- getReconstructedResult(tomoSeqObject, "gene2")
    result3 <- getReconstructedResult(tomoSeqObject, "gene3")
    result4 <- getReconstructedResult(tomoSeqObject, "gene4")

    true1 <- getReconstructedResult(trueResults, "gene1")
    true2 <- getReconstructedResult(trueResults, "gene2")
    true3 <- getReconstructedResult(trueResults, "gene3")
    true4 <- getReconstructedResult(trueResults, "gene4")
    expect_equal(sum((result1 - true1)^2), 0, tolerance=1e-6)
    expect_equal(sum((result2 - true2)^2), 0, tolerance=1e-6)
    expect_equal(sum((result3 - true3)^2), 0, tolerance=1e-6)
    expect_equal(sum((result4 - true4)^2), 0, tolerance=1e-6)
})

test_that("Extract peak genes at axial", {
    load("results_FindAxialGenes.rda")
    data("testx")
    testAll <- findAxialGenes(testx)
    testPartial <- findAxialGenes(testx, genes = c("gene1", "gene3"))
    expect_equal(testAll, resultAll, tolerance=1e-6)
    expect_equal(testPartial, resultPartial, tolerance=1e-6)
})

#' Make mask
#' @importFrom shiny
#'    fluidPage
#'    tags
#'    titlePanel
#'    sidebarPanel
#'    h4
#'    inputPanel
#'    radioButtons
#'    fileInput
#'    conditionalPanel
#'    numericInput
#'    actionButton
#'    downloadButton
#'    mainPanel
#'    textOutput
#'    observeEvent
#'    renderText
#'    downloadHandler
#'    shinyApp
#'    addResourcePath
#'    removeResourcePath
#' @return NA
#' @examples
#' if (interactive()) {
#'     masker()
#' }
#' @export
masker <- function () {
    ui <- function () {
        addResourcePath(
            'www',
            system.file("shinyApp/www", package = "tomoseqr")
        )
        on.exit(removeResourcePath('www'))
        fluidPage(
            tags$head(
                tags$link(
                    rel = "stylesheet",
                    type = "text/css",
                    href = "www/custom_style.css"
                )
            ),
            titlePanel("Masker (tomoseqr mask maker)"),
            sidebarPanel(style = "overflow-y: scroll; max-height: 730px",
                h4("Input style"),
                inputPanel(
                    radioButtons(
                        "how_input",
                        label = "How input",
                        choices = list("New mask" = 1, "From file" = 2),
                        selected = 1
                    ),
                    fileInput("mask_file", label = "Mask file")
                ),
                conditionalPanel(condition = "input.how_input == 1",
                    h4("Number of intercept"),
                    inputPanel(
                        numericInput(
                            "x_len",
                            label = "x",
                            width = 100,
                            value = 10
                        ),
                        numericInput(
                            "y_len",
                            label = "y",
                            width = 100,
                            value = 10
                        ),
                        numericInput(
                            "z_len",
                            label = "z",
                            width = 100,
                            value = 10
                        )
                    )
                ),
                h4("Width of cells"),
                inputPanel(
                    numericInput(
                        "x_ratio",
                        label = "x",
                        width = 100,
                        value = 10
                    ),
                    numericInput(
                        "y_ratio",
                        label = "y",
                        width = 100,
                        value = 10
                    ),
                    numericInput(
                        "z_ratio",
                        label = "z",
                        width = 100,
                        value = 10
                    )
                ),
                h4("Along which axis?"),
                inputPanel(
                    radioButtons(
                        "axis",
                        choices = list("x" = 1, "y" = 2, "z" = 3),
                        selected = 1,
                        label = "axis"
                    )
                ),
                actionButton(inputId = "sendToJs", label = "make table"),
                downloadButton("downloadData", label = "Download as .rda")
            ),
            mainPanel(
                tags$p(
                    tags$div(class = "table_button",
                        tags$button("back", onclick = "back_click()"),
                        tags$button("next", onclick = "next_click()"),
                        tags$button("Pencil", onclick = "SetPencil()"),
                        tags$button("Eraser", onclick = "SetEraser()"),
                        tags$button("Copy", onclick = "CopyCanvas()"),
                        tags$button("Paste", onclick = "PasteCanvas()")
                    )
                ),
                textOutput("h_axis"),
                textOutput("v_axis"),
                tags$p(
                    tags$div(id = "position"),
                    tags$div(id="nowPage"),
                ),
                tags$canvas(id="sample"),
                tags$div(class="tmp_canvas",
                tags$canvas(id="tmpCanvas")
                ),
                tags$script(src="www/first_load.js")
            )
        )
    }

    server <- function (input, output, session) {
        observeEvent(input$sendToJs, {
            if (input$how_input == 1) {
                x_len <- input$x_len
                y_len <- input$y_len
                z_len <- input$z_len
                x_ratio <- input$x_ratio
                y_ratio <- input$y_ratio
                z_ratio <- input$z_ratio
                data_matrix <- array(0, dim = c(x_len, y_len, z_len))
                if (input$axis == 1) {
                    data_matrix <- aperm(data_matrix, perm=c(2, 3, 1))
                    mask_dim <- dim(data_matrix)
                    output$h_axis <- renderText("Horizontal axis: y")
                    output$v_axis <- renderText("Vertical axis: z")
                    session$sendCustomMessage(
                        "initData",
                        message = list(
                            dataMatrix = data_matrix,
                            maskDim = mask_dim,
                            ratio = c(y_ratio, z_ratio),
                            alongAxis = "x"
                        )
                    )
                } else if (input$axis == 2) {
                    data_matrix <- aperm(data_matrix, perm=c(1, 3, 2))
                    mask_dim <- dim(data_matrix)
                    output$h_axis <- renderText("Horizontal axis: x")
                    output$v_axis <- renderText("Vertical axis: z")
                    session$sendCustomMessage(
                        "initData",
                        message = list(
                            dataMatrix = data_matrix,
                            maskDim = mask_dim,
                            ratio = c(x_ratio, z_ratio),
                            alongAxis = "y"
                        )
                    )
                } else {
                    mask_dim <- dim(data_matrix)
                    output$h_axis <- renderText("Horizontal axis: z")
                    output$v_axis <- renderText("Vertical axis: y")
                    session$sendCustomMessage(
                        "initData",
                        message = list(
                            dataMatrix = data_matrix,
                            maskDim = mask_dim,
                            ratio = c(x_ratio, y_ratio),
                            alongAxis = "z"
                        )
                    )
                }
            } else {
                ## File-loading process
                inFile <- input$mask_file
                file <- inFile$datapath
                e <- new.env()
                name <- load(file, envir = e)
                data_matrix <- e[[name]]

                x_ratio <- input$x_ratio
                y_ratio <- input$y_ratio
                z_ratio <- input$z_ratio

                if (input$axis == 1) {
                    data_matrix <- aperm(data_matrix, perm = c(2, 3, 1))
                    mask_dim <- dim(data_matrix)
                    output$h_axis <- renderText("Horizontal axis: y")
                    output$v_axis <- renderText("Vertical axis: z")
                    session$sendCustomMessage(
                        "existingData",
                        message = list(
                            dataMatrix = data_matrix,
                            ratio = c(y_ratio, z_ratio),
                            alongAxis = "x"
                        )
                    )
                } else if (input$axis == 2) {
                    data_matrix <- aperm(data_matrix, perm = c(1, 3, 2))
                    mask_dim <- dim(data_matrix)
                    output$h_axis <- renderText("Horizontal axis: x")
                    output$v_axis <- renderText("Vertical axis: z")
                    session$sendCustomMessage(
                        "existingData",
                        message = list(
                            dataMatrix = data_matrix,
                            ratio = c(x_ratio, z_ratio),
                            alongAxis = "y"
                        )
                    )
                } else {
                    mask_dim <- dim(data_matrix)
                    output$h_axis <- renderText("Horizontal axis: x")
                    output$v_axis <- renderText("Vertical axis: y")
                    session$sendCustomMessage(
                        "existingData",
                        message = list(
                            dataMatrix = data_matrix,
                            ratio = c(x_ratio, y_ratio),
                            alongAxis = "z"
                        )
                    )
                }
            }
        })

        output$downloadData <- downloadHandler(
            filename = "mask.rda",
            content = function(file) {
                mask_matrix <- input$mask_matrix %>%
                    array(dim = rev(input$mask_dim)) %>%
                    aperm(perm = c(3, 2, 1))
                if (input$along_axis == "x") {
                    mask_matrix <- aperm(mask_matrix, perm = c(3, 1, 2))
                } else if (input$along_axis == "y") {
                    mask_matrix <- aperm(mask_matrix, perm = c(1, 3, 2))
                }
                save(mask_matrix, file = file)
            }
        )
    }

    shinyApp(ui, server)
}

#' @importFrom methods is
#' @importFrom dplyr %>%
#' @importFrom stringr str_c
checkParameters <- function(tomoObj, query) {
    if (is(tomoObj, "tomoSeq") == FALSE) {
        stopMessage <- str_c(
            "invalid class: ",
            class(tomoObj),
            "\nFirst argument must be tomoSeq class object."
        )
        stop(stopMessage)
    }
    if (is.element(query, names(tomoObj[["results"]])) %>% min() == 0) {
        queryNotIn <- query[is.element(query, tomoObj[["results"]]) == FALSE]
        queryNotInStr <- str_c(queryNotIn, sep=", ")
        stopMessage <- str_c(queryNotInStr, ' is not in data.')
        stop(stopMessage)
    }
}

## This function is used in estimate3dExpression().
#' @importFrom dplyr %>%
getGeneExpression <- function (tomoSeqData, geneID) {
    retvalMatrix <- tomoSeqData[as.vector(tomoSeqData[, 1] == geneID), ]
    retvalMatrix <- retvalMatrix[, -1] %>% as.matrix()
    return(retvalMatrix)
}

repMat <- function (targetVector, nTimesRepeat) {
    lenX <- length(targetVector) * nTimesRepeat[1]
    lenY <- nTimesRepeat[2]
    lenZ <- nTimesRepeat[3]
    rep2d <- matrix(targetVector, nrow=lenX, ncol=lenY, byrow = FALSE)
    rep3d <- array(rep2d, dim=c(lenX, lenY, lenZ))
    return(rep3d)
}

#' @importFrom dplyr %>%
singleEstimate <- function (
    geneID,
    dataX,
    dataY,
    dataZ,
    mask,
    normalize,
    numIter
) {
    sumPerSectionX <- dataX[, -1] %>% colSums()
    sumPerSectionY <- dataY[, -1] %>% colSums()
    sumPerSectionZ <- dataZ[, -1] %>% colSums()

    xk <- dataX %>% getGeneExpression(geneID)
    yk <- dataY %>% getGeneExpression(geneID)
    zk <- dataZ %>% getGeneExpression(geneID)
    xLen <- length(xk)
    yLen <- length(yk)
    zLen <- length(zk)

    maskSumX <- mask %>% apply(1, sum)
    maskSumY <- mask %>% apply(2, sum)
    maskSumZ <- mask %>% apply(3, sum)

    if (normalize) {
        xk<- xk / sumPerSectionX * maskSumX
        yk<- yk / sumPerSectionY * maskSumY
        zk<- zk / sumPerSectionZ * maskSumZ
    }

    xk[1, is.nan(xk)] <- 0
    yk[1, is.nan(yk)] <- 0
    zk[1, is.nan(zk)] <- 0
    xk[is.infinite(xk)] <- max(xk[xk < Inf])
    yk[is.infinite(yk)] <- max(zk[yk < Inf])
    zk[is.infinite(zk)] <- max(yk[zk < Inf])

    m <- mean(c(sum(sumPerSectionX), sum(sumPerSectionY), sum(sumPerSectionZ)))

    xk <- xk / sum(xk) * m
    yk <- yk / sum(yk) * m
    zk <- zk / sum(zk) * m
    reconstArray <- mask

    errFuncVal <- rep_len(0, numIter)
    dimMask <- dim(mask)
    for (i in seq_len(numIter)) {
        recArrX <- reconstArray %>% apply(1, sum)
        reconstArray <- reconstArray *
            repMat(xk / recArrX, c(1, dimMask[2], dimMask[3]))
        reconstArray[is.nan(reconstArray)] <- 0

        recArrY <- reconstArray %>% apply(2, sum)
        reconstArray <- reconstArray * aperm(
            repMat(yk / recArrY, c(1, dimMask[1], dimMask[3])),
            perm = c(2, 1, 3)
        )
        reconstArray[is.nan(reconstArray)] <- 0

        recArrZ <- reconstArray %>% apply(3, sum)
        reconstArray <- reconstArray * aperm(
            repMat(zk / recArrZ, c(1, dimMask[1], dimMask[2])),
            perm = c(2, 3, 1)
        )
        reconstArray[is.nan(reconstArray)] <- 0

        errFuncVal[i] <- sum((recArrX - xk)^2) +
            sum((recArrY - yk)^2) +
            sum((recArrZ - zk)^2)
    }

    retList <- list(
        "geneID" = geneID,
        "reconst" = reconstArray,
        "errFunc" = errFuncVal,
        "x" = xk[1, ],
        "y" = yk[1, ],
        "z" = zk[1, ]
    )
    return(retList)
}

#' @importFrom stringr str_c
make2DPlot <- function (
    sectionNumber,
    basePlot,
    expDf,
    along,
    xAxis,
    yAxis,
    main
) {
    xAxisParameter <- sym(xAxis)
    yAxisParameter <- sym(yAxis)
    value <- sym("value")
    print(
        basePlot +
            geom_tile(
                data=expDf[expDf[[along]] == sectionNumber,],
                aes(
                    x = !!xAxisParameter,
                    y = !!yAxisParameter,
                    fill=!!value
                )
            ) +
            ggtitle(str_c(main, " : ", sectionNumber))
    )
}


#' @importFrom shiny
#' incProgress
animateForGIF <- function (
    basePlot,
    expDf,
    dimOrder,
    along,
    xAxis,
    yAxis,
    main,
    forShiny
) {
    if (forShiny == FALSE) {
        message("Plotting", appendLF=FALSE)
    }
    ind <- seq_len(dimOrder[[along]][3])
    lapply(
        ind,
        make2DPlot,
        basePlot = basePlot,
        expDf = expDf,
        along = along,
        xAxis = xAxis,
        yAxis = yAxis,
        main = main
    )
    if (forShiny == TRUE) {
        incProgress(1, detail = "Converting to GIF. It takes long time...")
    } else {
        message("")
        message("Converting to GIF. It takes long time...")
    }
}

#' @export
print.tomoSeq <- function (x, ...) {
    cat("Gene list:\n")
    cat(names(x[["results"]]))
}

#' @importFrom dplyr %>%
matrixToDataFrame <- function (reconst) {
    vecReconst <- as.vector(reconst)
    dim <- dim(reconst)
    xlen <- dim[1]
    ylen <- dim[2]
    zlen <- dim[3]
    xIndex <- rep(seq_len(xlen), ylen * zlen)
    yIndex <- seq_len(ylen) %>%
        vapply(function (p) {rep(p, xlen)}, FUN.VALUE = seq_len(xlen)) %>%
        rep(zlen)
    zIndex <- seq_len(zlen) %>%
        vapply(
            function (p) {rep(p, xlen * ylen)},
            FUN.VALUE = seq_len(xlen * ylen)
        ) %>%
        as.vector()
    data.frame(x=xIndex, y=yIndex, z=zIndex, value=vecReconst) %>%
        return()
}

isPeakGene <- function (v, threshold = 10) {
    maxV <- max(v)
    indexOfMaxV <- which.max(v)
    meanExeptMaxV <- mean(v[-1 * indexOfMaxV])
    if((maxV > threshold) && (maxV > 10 * meanExeptMaxV)) {
        return(c(maxV, meanExeptMaxV, indexOfMaxV))
    } else {
        return(c(maxV, meanExeptMaxV, 0))
    }
}

#' @importFrom tibble tibble
findAxialGenesInner <- function (targetData) {
    retMat <- targetData %>%
        select(-1) %>%
        apply(MARGIN = 1, FUN = isPeakGene) %>%
        t()
    tibble(
        geneID = as.vector(t(targetData[, 1])),
        max = retMat[, 1],
        meanExeptMax = retMat[, 2],
        isPeakGene = retMat[, 3]
    ) %>%
        return()
}

#' @importFrom tools R_user_dir
#' @importFrom BiocFileCache BiocFileCache
getTomoseqrCache <- function() {
    cache <- R_user_dir("tomoseqrCache", which="cache")
    BiocFileCache(cache)
}

#' @importFrom BiocFileCache bfcquery
#' @importFrom BiocFileCache bfcadd
#' @importFrom BiocFileCache bfcneedsupdate
#' @importFrom BiocFileCache bfcdownload
downloadData <- function (bfc, rname, URL, verbose=FALSE) {
    rid <- bfcquery(bfc, rname, "rname")$rid
    if (!length(rid)) {
        if (verbose) {
            message("Downloading file")
        }
        rid <- names(bfcadd(bfc, rname, URL))
    }
    if (isTRUE(bfcneedsupdate(bfc, rid))) {
        bfcdownload(bfc, rid)
    }
}


show3d <- function(
    df,
    mask,
    threshold,
    clim,
    xlab,
    ylab,
    zlab,
    addMask,
    exp_size,
    exp_opacity,
    mask_size,
    mask_opacity,
    mask_color,
    aspX,
    aspY,
    aspZ
) {
    xlim <- max(df$x)
    ylim <- max(df$y)
    zlim <- max(df$z)
    maxLen <- max(xlim, ylim, zlim)
    plotResult <- plot_ly(
        df[df$value > threshold, ],
        x=~x,
        y=~y,
        z=~z,
        alpha_stroke = 0,
        size = I(exp_size),
        marker = list(
        color =~value,
        cmin = min(df$value),
        cmax = clim[2],
        showscale = TRUE,
        opacity = exp_opacity * 0.01,
        colorscale = "Viridis"
        )

    ) %>%
        add_markers() %>%
        layout(
            autosize = TRUE,
            showlegend = FALSE,
            scene = list(
            xaxis=list(
                title = xlab,
                range = c(0, xlim),
                gridcolor="#ffffff",
                zerolinecolor ="#ffffff"
            ),
            yaxis = list(
                title = ylab,
                range=c(0,ylim),
                gridcolor="#ffffff",
                zerolinecolor ="#ffffff"
            ),
            zaxis = list(
                title = zlab,
                range=c(0,zlim),
                gridcolor="#ffffff",
                zerolinecolor ="#ffffff"
            ),
            aspectratio = list(
                x=xlim / maxLen * aspX,
                y=ylim/maxLen * aspY,
                z=zlim/maxLen * aspZ
                )
            ),
            paper_bgcolor = "#000000",
            font = list(color="#ffffff")
        ) %>%
        config(
            toImageButtonOptions = list(
                format = "svg",
                filename = "myplot",
                width = 1000,
                height = 1000,
                scale = 3
            )
        )
    if (addMask == TRUE) {
        maskWithoutExp <- mask[(mask$value == 1 & df$value <= threshold),]
        plotResult %>%
            add_markers(
                data = maskWithoutExp,
                x = ~x,
                y=~y,
                z=~z,
                inherit = FALSE,
                alpha = mask_opacity * 0.01,
                # alpha = 0.2,
                alpha_stroke = 0,
                size = I(mask_size),
                color = I(mask_color)
            ) %>%
            return()
    } else {
        return(plotResult)
    }
}

showExp <- function(
    tomoObj,
    geneID,
    threshold,
    xlab,
    ylab,
    zlab,
    addMask,
    exp_size,
    exp_opacity,
    mask_size,
    mask_opacity,
    mask_color,
    aspX,
    aspY,
    aspZ
    ) {
    df <- toDataFrame(tomoObj, geneID)
    mask <- matrixToDataFrame(tomoObj[["mask"]])
    show3d(
        df,
        mask,
        threshold,
        c(threshold, max(df$value)),
        xlab = xlab,
        ylab = ylab,
        zlab = zlab,
        addMask = addMask,
        exp_size = exp_size,
        exp_opacity = exp_opacity,
        mask_size = mask_size,
        mask_opacity = mask_opacity,
        mask_color = mask_color,
        aspX,
        aspY,
        aspZ
    )
}
plotsurface <- function(arr) {
    dimarr <- dim(arr)
    arrSurZero <- array(
        0,
        dim = c(
            dimarr[1] + 2,
            dimarr[2] + 2,
            dimarr[3] + 2
        )
    )
    dimArrS <- dim(arrSurZero)
    xCenter <- 2:(dimArrS[1] - 1)
    xLeftShift <- seq_len(dimArrS[1] - 2)
    xRightShift <- 3:dimArrS[1]
    yCenter <- 2:(dimArrS[2] - 1)
    yLeftShift <- seq_len(dimArrS[2] - 2)
    yRightShift <- 3:dimArrS[2]
    zCenter <- 2:(dimArrS[3] - 1)
    zLeftShift <- seq_len(dimArrS[3] - 2)
    zRightShift <- 3:dimArrS[3]

    arrSurZero[xCenter, yCenter, zCenter] <- arr
    return(
        arr * (
            arrSurZero[xLeftShift, yCenter, zCenter] *
            arrSurZero[xRightShift, yCenter, zCenter] *
            arrSurZero[xCenter, yLeftShift, zCenter] *
            arrSurZero[xCenter, yRightShift, zCenter] *
            arrSurZero[xCenter, yCenter, zLeftShift] *
            arrSurZero[xCenter, yCenter, zRightShift]
            == 0
        )
    )
}

#' @importFrom grDevices hcl.colors
#' @importFrom ggplot2
#'      xlab
#'      ylab
#'      xlim
#'      ylim
makeBasePlot <- function(
    expDf,
    xAxis,
    yAxis, 
    xMax,
    yMax,
    xAsp,
    yAsp,
    xlabel,
    ylabel,
    zlim
) {
    xAxisParameter <- sym(xAxis)
    yAxisParameter <- sym(yAxis)
    value <- sym("value")
    return(
        ggplot(
            expDf,
            aes(
                x = !!xAxisParameter,
                y = !!yAxisParameter,
                fill = !!value
            )
        ) +
            scale_fill_gradientn(
                colors = hcl.colors(50, "Blues", rev = TRUE),
                limits = zlim
            ) +
            xlim(0.0, xMax) +
            ylim(0.0, yMax) +
            xlab(xlabel) +
            ylab(ylabel) +
            theme_minimal() +
            theme(
                plot.background= element_rect(fill="black"),
                text = element_text(color = "white", size=20),
                axis.line.x.bottom = element_line(color = "white"),
                axis.line.y.left = element_line(color = "white"),
                panel.grid.major = element_blank(),
                panel.grid.minor = element_blank(),
                axis.ticks=element_line(colour = "white"),
                axis.text=element_text(colour = "white", size=20)
                ) +
            theme(aspect.ratio = yAsp / xAsp)
    )
}

---
title: "R Package for Analyzing Tomo-seq Data"
author: "Ryosuke Matsuzawa"
output: BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{tomoseqr}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

# Introduction

Tomo-seq is a genome-wide RNA tomography method that combines combining
high-throughput RNA sequencing with cryosectioning for spatially resolved
transcriptomics.
In 2014, [Junker et al.](https://doi.org/10.1016/j.cell.2014.09.038) published a method for reconstructing 3D gene
expression patterns from tomoseq data (iterative proportional fitting ([Fienberg, 1970](https://doi.org/10.1214/aoms/1177696968))). tomoseqr is a package to run
this method in R. tomoseqr also includes a 3D silhouette maker
for samples and tools to visualize the reconstruction results.

# Installation and loading

Install the `tomoseqr` package with the following command.
```{r eval = FALSE}
# for bioconductor
if (!require("BiocManager"))
    install.packages("BiocManager")

BiocManager::install("tomoseqr")
```

Load the `tomoseqr` package with the following command.

```{r setup, message = FALSE}
library(tomoseqr)
```

# Data preparation

`tomoseqr` requires Tomo-seq data in three directions (x, y, and z-axes) and a mask.

## Tomo-seq data preparation

Tomo-seq data must meet the following conditions.


1. It is a data frame with a header.
1. The first column is the gene ID (string), and the second and subsequent
columns are the expression levels (numeric) at each sections.
1. The order of the second and subsequent rows is the same as the order of
the sections.
1. The second and subsequent rows are ordered from left to right
(not right to left) of the intercept for each axis.
1. One row corresponds to one gene.

The `tomoseqr` package provides artificial tomoseq data as an example.

```{r}
data(testx, testy, testz)
head(testx)
```

## Tomo-seq data from Junker 2014

You can download part of the Tomo-seq data published by [Junker et al.](https://www.sciencedirect.com/science/article/pii/S0092867414012264#mmc3) with following commands. 

```{r, eval = FALSE}
tomoCache <- downloadJunker2014()
junker2014 <- doadJunker2014(tomoCache)

sheldAV <- junker2014[["sheldAV"]]
sheldVD <- junker2014[["sheldVD"]]
sheldLR <- junker2014[["sheldLR"]]
mask <- junker2014[["mask"]]
```

## Mask data preparation

Mask is a 3-dimensional matrix that represents the shape of the sample.
The value of each element indicates whether a voxel is included in the
sample or not. For example, if the voxel at coordinates (2, 3, 4) is
contained in the material, then The value of the element (2, 3, 4) in
the mask is 1. Conversely, the voxel at coordinates (10, 11, 12) is not
included in the sample, then the value of the mask element (10, 11, 12)
is 0.

The `tomoseqr` package provides artificial mask data as an example.

```{r}
data(mask)
```

## How to use Masker (tomoseqr mask maker)

The `tomoseqr` package provides a tool to create mask data,
which can be run with the following command.

```{r eval = FALSE}
masker()
```

![Interface of masker](masker_image.png)

You can create mask data using masker by create cross sections along
certain axes.

1. To create a new mask, select `new mask` under `How input`.
1. Set the number of sections for each axis in the
`Number of intercept` field.
1. In `width of cells`, set the thickness of the intercept for each axis
as a relative value.
(This is only related to the appearance of the mask creation screen, so
it does not have to be strict.)
1. Set along which axis you create the mask in the `Along which axis?`
field.
1. Click `make table`, and a mask creation screen appears.
1. On the mask creation screen, create a cross-sectional view
as if you were creating pixel art.
1. Click `Download as .rda` to output mask data as rda file.

# Reconstruction of 3D expression patterns

Use the `estimate3dExpressions` function to reconstruct the 3D expression
pattern of the gene specified by `query` from Tomo-seq data.

```{r}
tomoObj <- estimate3dExpressions(
    testx,
    testy,
    testz,
    mask = mask,
    query = c("gene1", "gene2", "gene3")
)
```

# Visualize result of reconstruction

Visualize the reconstruction results using `imageViewer`.

```{r eval = FALSE}
imageViewer(tomoObj)
```

This command starts a shiny app `imageViewer`.

![Interface of ImageViewer (2D view)](2Dimage.png)

![Interface of ImageViewer (3D view)](3Dimage.png)

1. Select gene ID.
1. Edit labels of each axes.
1. Set the width of sections for each axis. it is used to calculate the
aspect ratio of figures.
1. Use this tab to switch between 2D and 3D views.
1. Select which axis to look at the cross section perpendicular to.
1. Move the slider to select the location you want to see. Press the Auto Play button to view each section of the image
frame by frame.
1. Edit figure titles and labels.
1. Specify the range of expression levels to be displayed (default is
the full range).
1. Rendering area.
1. Obtain a cross-sectional view (png) or a frame-by-frame image (gif)
of each fragment being displayed.
1. Threshold of expression level. Expression points with levels lower than
this value are not plotted.
1. Toggle whether or not to plot points representing the mask.

# Find axial peak gene

Detect genes with significant differences in expression levels between
sections from Tomo-seq data.

```{r}
axialGeneTable <- findAxialGenes(testx)
print(axialGeneTable)
```
The results include these columns:

- GeneID: Gene ID.  
- max: The maximum expression level of the gene.  
- meanExeptMax: Average of expression levels excluding the maximum.  
- index: Number of the section containing the maximum expression level.

You can also specify a vector of candidate gene IDs.

```{r}
axialGeneTable <- findAxialGenes(testx, genes = c("gene1", "gene3"))
print(axialGeneTable)
```

# SessionInfo

```{r}
sessionInfo()
```

\name{mask}
\alias{mask}
\docType{data}
\title{A matrix containing mask data.}
\description{
    It is a matrix representing the mask. Each element of the matrix
    corresponds to a voxel, and has the value 1 if the voxel is included
    in the mask, 0 if it is not.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{findAxialGenes}
\alias{findAxialGenes}
\title{Find peak genes on axial}
\usage{
findAxialGenes(tomoSeqData, genes = "all")
}
\arguments{
\item{tomoSeqData}{tomo-seq data of any axis}

\item{genes}{If run for all genes}
}
\value{
A data frame consisting of gene ID, max of expression levels of the
gene, mean of expression levels calculated by excluding the maximum value and
section number showing the maximum expression level (0 means that there is
no such section).
}
\description{
Find peak genes on axial
}
\examples{
data(testx)
findAxialGenes(testx)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/masker.R
\name{masker}
\alias{masker}
\title{Make mask}
\usage{
masker()
}
\value{
NA
}
\description{
Make mask
}
\examples{
if (interactive()) {
    masker()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{extractGeneList}
\alias{extractGeneList}
\title{Extract geneIDs to which hoge can be applied.}
\usage{
extractGeneList(x, y, z)
}
\arguments{
\item{x}{A data.frame object containing a Tomo-seq data
for x-axis sections. The rows represent genes. The first column
contains gene IDs and the second and subsequent columns contain
gene expression levels in sections.}

\item{y}{A data.frame object containing a Tomo-seq data for y-axis
sections. The rows represent genes. The first column contains gene IDs and
the second and subsequent columns contain gene expression levels in sections.}

\item{z}{A data.frame object containing a Tomo-seq data for
z-axis sections. The rows represent genes. The first column
contains gene IDs and the second and subsequent columns contain
gene expression levels in sections.}
}
\value{
A vector that contains genes which can be used for
\code{estimate3dExpressions}.
}
\description{
Extract geneIDs to which hoge can be applied.
}
\examples{
data("testx", "testy", "testz")
extractGeneList(testx, testy, testz)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ImageViewer.R
\name{imageViewer}
\alias{imageViewer}
\title{Output the reconstructed expression pattern as an image.}
\usage{
imageViewer(tomoObj)
}
\arguments{
\item{tomoObj}{tomoSeq object}
}
\value{
NA
}
\description{
Output the reconstructed expression pattern as an image.
}
\examples{
if (interactive()) {
    data(tomoObj)
    imageViewer(tomoObj, "gene2")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{plot1dExpression}
\alias{plot1dExpression}
\title{Plot expression of single gene along an axis}
\usage{
plot1dExpression(tomoObj, geneID, axes)
}
\arguments{
\item{tomoObj}{tomoSeq object}

\item{geneID}{single gene ID (string)}

\item{axes}{axis ("x", "y" or "z")}
}
\value{
NA
}
\description{
Plot expression of single gene along an axis
}
\examples{
data(tomoObj)
plot1dExpression(tomoObj, "gene2", "x")
}

\name{tomoObj}
\alias{tomoObj}
\docType{data}
\title{A tomoSeq object.}
\description{
    It is a tomoSeq object generated from \code{\link[tomoseqr]{testx}},
    \code{\link[tomoseqr]{testy}}, \code{\link[tomoseqr]{testz}} and
    \code{\link[tomoseqr]{mask}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{plotLossFunction}
\alias{plotLossFunction}
\title{Plot the trend of the value of the loss function.}
\usage{
plotLossFunction(tomoObj, geneID)
}
\arguments{
\item{tomoObj}{tomoSeq object}

\item{geneID}{single gene ID (string)}
}
\value{
NA
}
\description{
Plot the trend of the value of the loss function.
}
\examples{
data(tomoObj)
plotLossFunction(tomoObj, "gene2")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{downloadJunker2014}
\alias{downloadJunker2014}
\title{Download  part of the Tomo-seq data published by Junker et al.}
\usage{
downloadJunker2014(verbose = FALSE)
}
\arguments{
\item{verbose}{If you want to force downloads with or without cache,
set this to TRUE.}
}
\value{
BiocFileCache object.
}
\description{
Download  part of the Tomo-seq data published by Junker et al.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{plot1dAllExpression}
\alias{plot1dAllExpression}
\title{Plot expressions of all genes along an axis}
\usage{
plot1dAllExpression(tomoSeqData, ...)
}
\arguments{
\item{tomoSeqData}{A data.frame object containing a Tomo-seq data
for any sections. The rows represent genes. The first column
contains gene IDs and the second and subsequent columns contain
gene expression levels in sections.}

\item{...}{Arguments which are related to plot parameters.
Prease refer to \code{\link[graphics]{plot}}.}
}
\value{
NA
}
\description{
Plot expressions of all genes along an axis
}
\examples{
data("testx")
plot1dAllExpression(testx)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{toDataFrame}
\alias{toDataFrame}
\title{Convert reconstructed matrix to data.frame.}
\usage{
toDataFrame(tomoObj, geneID)
}
\arguments{
\item{tomoObj}{tomoSeq object}

\item{geneID}{single gene ID}
}
\value{
Reconstruction result converted to dataframe.
}
\description{
Convert reconstructed matrix to data.frame.
}
\examples{
data(tomoObj)
toDataFrame(tomoObj, "gene2")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{estimate3dExpressions}
\alias{estimate3dExpressions}
\title{Estimate 3d expressions}
\usage{
estimate3dExpressions(x, y, z, mask, query, numIter = 100, normalize = TRUE)
}
\arguments{
\item{x}{A data.frame object containing a simulated Tomo-seq data
for x-axis sections. The rows represent genes. The first column
contains gene IDs and the second and subsequent columns contain
gene expression levels in sections.}

\item{y}{A data.frame object containing a simulated Tomo-seq data for y-axis
sections. The rows represent genes. The first column contains gene IDs and
the second and subsequent columns contain gene expression levels in sections.}

\item{z}{A data.frame object containing a simulated Tomo-seq data for
z-axis sections. The rows represent genes. The first column
contains gene IDs and the second and subsequent columns contain
gene expression levels in sections.}

\item{mask}{A 3D array that represents if each boxel is included to sample.
You can make a mask using \code{masker}.}

\item{query}{Vector of gene IDs}

\item{numIter}{How many times iterate}

\item{normalize}{Whether to normalize so that total expression per sample
volume is equal between sections.}
}
\value{
tomoSeq object
}
\description{
Estimate 3d expressions
}
\examples{
data("testx", "testy", "testz", "mask")
estimate3dExpressions(
    testx,
    testy,
    testz,
    mask = mask,
    query = c("gene1"), 
    normalize = TRUE
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{getReconstructedResult}
\alias{getReconstructedResult}
\title{Get reconstructed matrix}
\usage{
getReconstructedResult(tomoObj, geneID)
}
\arguments{
\item{tomoObj}{tomoSeq object}

\item{geneID}{single gene ID}
}
\value{
Reconstruction result as matrix
}
\description{
Get reconstructed matrix
}
\examples{
data(tomoObj)
getReconstructedResult(tomoObj, "gene2")
}

\name{testz}
\alias{testz}
\docType{data}
\title{
    A data.frame object containing a simulated Tomo-seq data
    for z-axis sections.
}
\description{
    A data.frame object containing a simulated Tomo-seq data for z-axis
    sections. The rows represent genes. The first column contains gene IDs and
    the second and subsequent columns contain gene expression levels
    in sections.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{animate2d}
\alias{animate2d}
\title{Animate 2D expressions along one axis and generate GIF file.}
\usage{
animate2d(
  tomoObj,
  geneID,
  along = "x",
  main = geneID,
  xlab = "x",
  ylab = "y",
  file = str_c(geneID, "_", along, ".gif"),
  zlim = NA,
  interval = 0.1,
  aspectX = 1,
  aspectY = 1
)
}
\arguments{
\item{tomoObj}{tomoSeq object}

\item{geneID}{single gene ID (string)}

\item{along}{Parameter specifying along which axis the cross section should
be plotted.}

\item{main}{A string used for the title of the plot. Default is \code{geneID}.}

\item{xlab}{Label of x axis. Default is \code{xaxis}.}

\item{ylab}{Label of y axis. Default is \code{yaxis}.}

\item{file}{Path of GIF file.}

\item{zlim}{Limit of value of heatmap. If target="mask", it is ignored.}

\item{interval}{interval of GIF animation.}

\item{aspectX}{Width of figure. If you don't specify the value of
this parameter, It is calculated based on the number of sections
Corresponding to the horizontal axis}

\item{aspectY}{Height of figure. If you don't specify the value of
this parameter, It is calculated based on the number of sections
Corresponding to the vertical axis}
}
\value{
It generate GIF file.
}
\description{
Animate 2D expressions along one axis and generate GIF file.
}
\examples{
if(interactive()) {
    data(tomoObj)
    animate2d(tomoObj, "gene2", target = "expression", file = "example.gif")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_function.R
\name{doadJunker2014}
\alias{doadJunker2014}
\title{Load data of Junker2014 from cache.}
\usage{
doadJunker2014(tomoseqrCache)
}
\arguments{
\item{tomoseqrCache}{Cache of tomoseqr. You can get it using
\code{downloadJunker2014}.}
}
\value{
List of tomo-seq data in cache.
}
\description{
Load data of Junker2014 from cache.
}
